// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from nao_command_msgs:msg/SonarUsage.idl
// generated code does not contain a copyright notice

#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__SONAR_USAGE__TRAITS_HPP_
#define NAO_COMMAND_MSGS__MSG__DETAIL__SONAR_USAGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "nao_command_msgs/msg/detail/sonar_usage__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace nao_command_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SonarUsage & msg,
  std::ostream & out)
{
  out << "{";
  // member: left
  {
    out << "left: ";
    rosidl_generator_traits::value_to_yaml(msg.left, out);
    out << ", ";
  }

  // member: right
  {
    out << "right: ";
    rosidl_generator_traits::value_to_yaml(msg.right, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SonarUsage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: left
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "left: ";
    rosidl_generator_traits::value_to_yaml(msg.left, out);
    out << "\n";
  }

  // member: right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "right: ";
    rosidl_generator_traits::value_to_yaml(msg.right, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SonarUsage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace nao_command_msgs

namespace rosidl_generator_traits
{

[[deprecated("use nao_command_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const nao_command_msgs::msg::SonarUsage & msg,
  std::ostream & out, size_t indentation = 0)
{
  nao_command_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use nao_command_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const nao_command_msgs::msg::SonarUsage & msg)
{
  return nao_command_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<nao_command_msgs::msg::SonarUsage>()
{
  return "nao_command_msgs::msg::SonarUsage";
}

template<>
inline const char * name<nao_command_msgs::msg::SonarUsage>()
{
  return "nao_command_msgs/msg/SonarUsage";
}

template<>
struct has_fixed_size<nao_command_msgs::msg::SonarUsage>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<nao_command_msgs::msg::SonarUsage>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<nao_command_msgs::msg::SonarUsage>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__SONAR_USAGE__TRAITS_HPP_
